/* Created on 1-ott-2005 */
package jtelnet.gui;

import java.awt.BorderLayout;
import java.io.IOException;
import java.net.UnknownHostException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import sun.security.krb5.internal.j;

import jtelnet.DisplayDriver;
import jtelnet.JTelnet;
import javax.swing.JScrollPane;
import javax.swing.JCheckBox;

public class JTelnetGui extends JFrame implements DisplayDriver {

	private JPanel jContentPane = null;
	private JPanel jPanel = null;
	private JPanel jPanel1 = null;
	private JTextField jTextField = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JTextField jTextField1 = null;
	private JButton jButton = null;
	private JButton jButton1 = null;
	private JLabel jLabel2 = null;
	private JTextField jTextField2 = null;
	private JTelnetGui jtelnetgui = null;
	private JTelnet jTelnet = null;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	private JCheckBox jCheckBox = null;
	public void notify(String text) {
		this.jTextArea.append(text + (char) 10 + (char) 13);
	}

	/**
	 * This is the default constructor
	 */
	public JTelnetGui() {
		super();
		initialize();
		this.jtelnetgui = this;
		this.jTelnet = new JTelnet();
		this.jTelnet.addDisplayDriver(this);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setPreferredSize(new java.awt.Dimension(480,330));
		this.setSize(508, 354);
		this.setContentPane(getJContentPane());
		this.setTitle("JTelnet");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), java.awt.BorderLayout.NORTH);
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel2 = new JLabel();
			jLabel2.setText("Info -");
			jLabel2.setPreferredSize(new java.awt.Dimension(475,15));
			jLabel1 = new JLabel();
			jLabel1.setText("Port");
			jLabel = new JLabel();
			jLabel.setText("Host");
			jPanel = new JPanel();
			jPanel.setPreferredSize(new java.awt.Dimension(631,60));
			jPanel.add(jLabel, null);
			jPanel.add(getJTextField(), null);
			jPanel.add(jLabel1, null);
			jPanel.add(getJTextField1(), null);
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton1(), null);
			jPanel.add(getJCheckBox(), null);
			jPanel.add(jLabel2, null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.add(getJTextField2(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setPreferredSize(new java.awt.Dimension(150,19));
		}
		return jTextField;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setPreferredSize(new java.awt.Dimension(40,19));
		}
		return jTextField1;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Connect");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jLabel2.setText("Info -");
					jTelnet.setIp(jTextField.getText());
					jTelnet.setPort(Integer.parseInt(jTextField1.getText()));
					try {
						jTelnet.connect();
					} catch (UnknownHostException e1) {
						jLabel2.setText("Unknown Host");
					} catch (IOException e1) {
						jLabel2.setText("IO Exception");
					} // TODO Auto-generated Event stub actionPerformed()
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Stop");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					jTelnet.closeConnection();
					jTextArea.setText("");
					jLabel2.setText("Info - Connection closed");
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setColumns(40);
			jTextField2.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					char c = e.getKeyChar(); // TODO Auto-generated Event stub keyTyped()
					if (c == 10 || c == 13) {
						String command = jTextField2.getText();
						boolean sent = jtelnetgui.sendCommand(command);
						if (sent && jCheckBox.isSelected()) 
							jTextArea.append(command + (char) 10 + (char) 13);
						jTextField2.setText("");
					}
				}
			});
			
		}
		return jTextField2;
	}

	protected boolean sendCommand(String string) {
		return this.jTelnet.sendCommand(string);
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setLineWrap(true);
			jTextArea.setBackground(java.awt.Color.black);
			jTextArea.setForeground(java.awt.Color.white);
			jTextArea.setWrapStyleWord(true);
		}
		return jTextArea;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Echo");
		}
		return jCheckBox;
	}

	/**
	 * Launches this application
	 */
	public static void main(String[] args) {
		JTelnetGui application = new JTelnetGui();
		application.show();
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
